Index: trunk/modules/vci_mem_cache_v4/caba/source/src/vci_mem_cache_v4.cpp
===================================================================
--- trunk/modules/vci_mem_cache_v4/caba/source/src/vci_mem_cache_v4.cpp	(revision 253)
+++ trunk/modules/vci_mem_cache_v4/caba/source/src/vci_mem_cache_v4.cpp	(revision 273)
@@ -4659,35 +5049,35 @@
         }
         /////////////////////////
-        case INIT_CMD_INVAL_IDLE:	// WRITE FSM has highest priority
+        case INIT_CMD_INVAL_IDLE: // WRITE FSM has highest priority
         {
             if ( m_write_to_init_cmd_inst_fifo.rok() ||
-                 r_write_to_init_cmd_multi_req.read() ) 
+                 r_write_to_init_cmd_multi_req.read() )
             {
                 r_init_cmd_fsm = INIT_CMD_UPDT_NLINE;
                 m_cpt_update++;
-            } 
+            }
             else if ( r_write_to_init_cmd_brdcast_req.read() )
             {
                 r_init_cmd_fsm = INIT_CMD_WRITE_BRDCAST;
                 m_cpt_inval++;
-            } 
+            }
             else if ( m_sc_to_init_cmd_inst_fifo.rok() ||
-                      r_sc_to_init_cmd_multi_req.read()  ) 
+                      r_sc_to_init_cmd_multi_req.read()  )
             {
                 r_init_cmd_fsm = INIT_CMD_SC_UPDT_NLINE;
                 m_cpt_update++;
-            } 
+            }
             else if( r_sc_to_init_cmd_brdcast_req.read() )
             {
                 r_init_cmd_fsm = INIT_CMD_SC_BRDCAST;
                 m_cpt_inval++;
-            } 
+            }
             else if ( m_xram_rsp_to_init_cmd_inst_fifo.rok() ||
-                      r_xram_rsp_to_init_cmd_multi_req.read()  ) 
+                      r_xram_rsp_to_init_cmd_multi_req.read()  )
             {
                 r_init_cmd_fsm = INIT_CMD_INVAL_NLINE;
                 m_cpt_inval++;
-            } 
-            else if ( r_xram_rsp_to_init_cmd_brdcast_req.read() ) 
+            }
+            else if ( r_xram_rsp_to_init_cmd_brdcast_req.read() )
             {
                 r_init_cmd_fsm = INIT_CMD_XRAM_BRDCAST;
@@ -4697,34 +5087,34 @@
         }
         //////////////////////////
-        case INIT_CMD_SC_UPDT_IDLE:	// SC FSM has highest priority
+        case INIT_CMD_SC_UPDT_IDLE: // SC FSM has highest priority
         {
             if ( m_sc_to_init_cmd_inst_fifo.rok() ||
-                 r_sc_to_init_cmd_multi_req.read()  ) 
+                 r_sc_to_init_cmd_multi_req.read()  )
             {
                 r_init_cmd_fsm = INIT_CMD_SC_UPDT_NLINE;
                 m_cpt_update++;
-            } 
+            }
             else if( r_sc_to_init_cmd_brdcast_req.read() )
             {
                 r_init_cmd_fsm = INIT_CMD_SC_BRDCAST;
                 m_cpt_inval++;
-            } 
+            }
             else if ( m_xram_rsp_to_init_cmd_inst_fifo.rok() ||
-                      r_xram_rsp_to_init_cmd_multi_req.read()  ) 
+                      r_xram_rsp_to_init_cmd_multi_req.read()  )
             {
                 r_init_cmd_fsm = INIT_CMD_INVAL_NLINE;
                 m_cpt_inval++;
-            } 
-            else if ( r_xram_rsp_to_init_cmd_brdcast_req.read() ) 
+            }
+            else if ( r_xram_rsp_to_init_cmd_brdcast_req.read() )
             {
                 r_init_cmd_fsm = INIT_CMD_XRAM_BRDCAST;
                 m_cpt_inval++;
-            } 
+            }
             else if ( m_write_to_init_cmd_inst_fifo.rok() ||
-                      r_write_to_init_cmd_multi_req.read() ) 
+                      r_write_to_init_cmd_multi_req.read() )
             {
                 r_init_cmd_fsm = INIT_CMD_UPDT_NLINE;
                 m_cpt_update++;
-            } 
+            }
             else if ( r_write_to_init_cmd_brdcast_req.read() )
             {
@@ -4735,9 +5125,9 @@
         }
         //////////////////////////
-        case INIT_CMD_INVAL_NLINE:	// send a multi-inval (from XRAM_RSP)
+        case INIT_CMD_INVAL_NLINE:  // send a multi-inval (from XRAM_RSP)
         {
             if ( m_xram_rsp_to_init_cmd_inst_fifo.rok() )
             {
-                if ( p_vci_ini.cmdack ) 
+                if ( p_vci_ini.cmdack )
                 {
                     m_cpt_inval_mult++;
@@ -4745,6 +5135,6 @@
                     xram_rsp_to_init_cmd_fifo_get = true;
                 }
-            } 
-            else 
+            }
+            else
             {
                 if( r_xram_rsp_to_init_cmd_multi_req.read() ) r_xram_rsp_to_init_cmd_multi_req = false;
@@ -4754,7 +5144,7 @@
         }
         ///////////////////////////
-        case INIT_CMD_XRAM_BRDCAST:	// send a broadcast-inval (from XRAM_RSP)
-        {
-            if ( p_vci_ini.cmdack ) 
+        case INIT_CMD_XRAM_BRDCAST: // send a broadcast-inval (from XRAM_RSP)
+        {
+            if ( p_vci_ini.cmdack )
             {
                 m_cpt_inval_brdcast++;
@@ -4765,7 +5155,7 @@
         }
         ////////////////////////////
-        case INIT_CMD_WRITE_BRDCAST:	// send a broadcast-inval (from WRITE FSM)
-        {
-            if( p_vci_ini.cmdack ) 
+        case INIT_CMD_WRITE_BRDCAST:  // send a broadcast-inval (from WRITE FSM)
+        {
+            if( p_vci_ini.cmdack )
             {
 
@@ -4773,5 +5163,5 @@
 if( m_debug_init_cmd_fsm )
 {
-    std::cout << "  <MEMC " << name() << ".INIT_CMD_WRITE_BRDCAST> Broadcast-Inval for line " 
+    std::cout << "  <MEMC " << name() << ".INIT_CMD_WRITE_BRDCAST> Broadcast-Inval for line "
               << r_write_to_init_cmd_nline.read() << std::endl;
 }
@@ -4786,5 +5176,5 @@
         case INIT_CMD_UPDT_NLINE:  // send nline for a multi-update (from WRITE FSM)
         {
-            if ( m_write_to_init_cmd_inst_fifo.rok() ) 
+            if ( m_write_to_init_cmd_inst_fifo.rok() )
             {
                 if ( p_vci_ini.cmdack )
@@ -4794,6 +5184,6 @@
                     // write_to_init_cmd_fifo_get = true;
                 }
-            } 
-            else 
+            }
+            else
             {
                 if ( r_write_to_init_cmd_multi_req.read() ) r_write_to_init_cmd_multi_req = false;
@@ -4812,12 +5202,12 @@
         case INIT_CMD_UPDT_DATA:  // send the data for a multi-update (from WRITE FSM)
         {
-            if ( p_vci_ini.cmdack ) 
-            {
-                if ( r_init_cmd_cpt.read() == (r_write_to_init_cmd_count.read()-1) ) 
+            if ( p_vci_ini.cmdack )
+            {
+                if ( r_init_cmd_cpt.read() == (r_write_to_init_cmd_count.read()-1) )
                 {
                     r_init_cmd_fsm = INIT_CMD_UPDT_NLINE;
                     write_to_init_cmd_fifo_get = true;
-                } 
-                else 
+                }
+                else
                 {
                     r_init_cmd_cpt = r_init_cmd_cpt.read() + 1;
@@ -4827,7 +5217,7 @@
         }
         /////////////////////////
-        case INIT_CMD_SC_BRDCAST:	// send a broadcast-inval (from SC FSM)
-        {
-            if( p_vci_ini.cmdack ) 
+        case INIT_CMD_SC_BRDCAST: // send a broadcast-inval (from SC FSM)
+        {
+            if( p_vci_ini.cmdack )
             {
                 m_cpt_inval_brdcast++;
@@ -4847,6 +5237,6 @@
                     r_init_cmd_fsm = INIT_CMD_SC_UPDT_INDEX;
                 }
-            } 
-            else 
+            }
+            else
             {
                 if( r_sc_to_init_cmd_multi_req.read() ) r_sc_to_init_cmd_multi_req = false;
@@ -4862,13 +5252,13 @@
         }
         ///////////////////////////
-        case INIT_CMD_SC_UPDT_DATA:  // send first data for a multi-update (from SC FSM) 
-        {
-            if ( p_vci_ini.cmdack ) 
+        case INIT_CMD_SC_UPDT_DATA:  // send first data for a multi-update (from SC FSM)
+        {
+            if ( p_vci_ini.cmdack )
             {
                 if ( r_sc_to_init_cmd_is_long.read() )
                 {
                     r_init_cmd_fsm = INIT_CMD_SC_UPDT_DATA_HIGH;
-                } 
-                else 
+                }
+                else
                 {
                     sc_to_init_cmd_fifo_get = true;
@@ -4881,5 +5271,5 @@
         case INIT_CMD_SC_UPDT_DATA_HIGH:  // send second data for a multi-update (from SC FSM)
         {
-            if ( p_vci_ini.cmdack ) 
+            if ( p_vci_ini.cmdack )
             {
                 sc_to_init_cmd_fifo_get = true;
@@ -4891,5 +5281,5 @@
 
     /////////////////////////////////////////////////////////////////////
-    //		TGT_RSP FSM
+    //    TGT_RSP FSM
     /////////////////////////////////////////////////////////////////////
     // The TGT_RSP fsm sends the responses on the VCI target port
@@ -4904,12 +5294,12 @@
     /////////////////////////////////////////////////////////////////////
 
-    switch ( r_tgt_rsp_fsm.read() ) 
+    switch ( r_tgt_rsp_fsm.read() )
     {
         ///////////////////////
-        case TGT_RSP_READ_IDLE:		// write requests have the highest priority
+        case TGT_RSP_READ_IDLE:   // write requests have the highest priority
         {
           if      ( r_write_to_tgt_rsp_req    ) r_tgt_rsp_fsm = TGT_RSP_WRITE;
           else if ( r_sc_to_tgt_rsp_req     ) r_tgt_rsp_fsm = TGT_RSP_SC;
-          else if ( r_xram_rsp_to_tgt_rsp_req ) 
+          else if ( r_xram_rsp_to_tgt_rsp_req )
           {
             r_tgt_rsp_fsm = TGT_RSP_XRAM;
@@ -4918,5 +5308,5 @@
           else if ( r_init_rsp_to_tgt_rsp_req ) r_tgt_rsp_fsm = TGT_RSP_INIT;
           else if ( r_cleanup_to_tgt_rsp_req  ) r_tgt_rsp_fsm = TGT_RSP_CLEANUP;
-          else if ( r_read_to_tgt_rsp_req     ) 
+          else if ( r_read_to_tgt_rsp_req     )
           {
             r_tgt_rsp_fsm = TGT_RSP_READ;
@@ -4926,8 +5316,8 @@
         }
         ////////////////////////
-        case TGT_RSP_WRITE_IDLE:	// sc requests have the highest priority
+        case TGT_RSP_WRITE_IDLE:  // sc requests have the highest priority
         {
           if      ( r_sc_to_tgt_rsp_req     ) r_tgt_rsp_fsm = TGT_RSP_SC;
-          else if ( r_xram_rsp_to_tgt_rsp_req ) 
+          else if ( r_xram_rsp_to_tgt_rsp_req )
           {
             r_tgt_rsp_fsm = TGT_RSP_XRAM;
@@ -4936,5 +5326,5 @@
           else if ( r_init_rsp_to_tgt_rsp_req ) r_tgt_rsp_fsm = TGT_RSP_INIT;
           else if ( r_cleanup_to_tgt_rsp_req  ) r_tgt_rsp_fsm = TGT_RSP_CLEANUP;
-          else if ( r_read_to_tgt_rsp_req     ) 
+          else if ( r_read_to_tgt_rsp_req     )
           {
             r_tgt_rsp_fsm = TGT_RSP_READ;
@@ -4946,7 +5336,7 @@
         }
         ///////////////////////
-        case TGT_RSP_SC_IDLE:		// xram_rsp requests have the highest priority
-        {
-          if ( r_xram_rsp_to_tgt_rsp_req )  
+        case TGT_RSP_SC_IDLE:   // xram_rsp requests have the highest priority
+        {
+          if ( r_xram_rsp_to_tgt_rsp_req )
           {
             r_tgt_rsp_fsm = TGT_RSP_XRAM;
@@ -4955,5 +5345,5 @@
           else if ( r_init_rsp_to_tgt_rsp_req ) r_tgt_rsp_fsm = TGT_RSP_INIT;
           else if ( r_cleanup_to_tgt_rsp_req  ) r_tgt_rsp_fsm = TGT_RSP_CLEANUP;
-          else if ( r_read_to_tgt_rsp_req     ) 
+          else if ( r_read_to_tgt_rsp_req     )
           {
             r_tgt_rsp_fsm = TGT_RSP_READ;
@@ -4965,10 +5355,10 @@
         }
         ///////////////////////
-        case TGT_RSP_XRAM_IDLE:		// init requests have the highest priority
+        case TGT_RSP_XRAM_IDLE:   // init requests have the highest priority
         {
 
           if      ( r_init_rsp_to_tgt_rsp_req ) r_tgt_rsp_fsm = TGT_RSP_INIT;
           else if ( r_cleanup_to_tgt_rsp_req  ) r_tgt_rsp_fsm = TGT_RSP_CLEANUP;
-          else if ( r_read_to_tgt_rsp_req     ) 
+          else if ( r_read_to_tgt_rsp_req     )
           {
             r_tgt_rsp_fsm = TGT_RSP_READ;
@@ -4977,5 +5367,5 @@
           else if ( r_write_to_tgt_rsp_req    ) r_tgt_rsp_fsm = TGT_RSP_WRITE;
           else if ( r_sc_to_tgt_rsp_req     ) r_tgt_rsp_fsm = TGT_RSP_SC;
-          else if ( r_xram_rsp_to_tgt_rsp_req )  
+          else if ( r_xram_rsp_to_tgt_rsp_req )
           {
             r_tgt_rsp_fsm = TGT_RSP_XRAM;
@@ -4985,8 +5375,8 @@
         }
         ///////////////////////
-        case TGT_RSP_INIT_IDLE:		// cleanup requests have the highest priority
+        case TGT_RSP_INIT_IDLE:   // cleanup requests have the highest priority
         {
           if      ( r_cleanup_to_tgt_rsp_req  ) r_tgt_rsp_fsm = TGT_RSP_CLEANUP;
-          else if ( r_read_to_tgt_rsp_req     ) 
+          else if ( r_read_to_tgt_rsp_req     )
           {
             r_tgt_rsp_fsm = TGT_RSP_READ;
@@ -4995,5 +5385,5 @@
           else if ( r_write_to_tgt_rsp_req    ) r_tgt_rsp_fsm = TGT_RSP_WRITE;
           else if ( r_sc_to_tgt_rsp_req     ) r_tgt_rsp_fsm = TGT_RSP_SC;
-          else if ( r_xram_rsp_to_tgt_rsp_req ) 
+          else if ( r_xram_rsp_to_tgt_rsp_req )
           {
             r_tgt_rsp_fsm = TGT_RSP_XRAM;
@@ -5004,7 +5394,7 @@
         }
         ///////////////////////
-        case TGT_RSP_CLEANUP_IDLE:		// read requests have the highest priority
-        {
-          if      ( r_read_to_tgt_rsp_req     ) 
+        case TGT_RSP_CLEANUP_IDLE:    // read requests have the highest priority
+        {
+          if      ( r_read_to_tgt_rsp_req     )
           {
             r_tgt_rsp_fsm = TGT_RSP_READ;
@@ -5013,5 +5403,5 @@
           else if ( r_write_to_tgt_rsp_req    ) r_tgt_rsp_fsm = TGT_RSP_WRITE;
           else if ( r_sc_to_tgt_rsp_req     ) r_tgt_rsp_fsm = TGT_RSP_SC;
-          else if ( r_xram_rsp_to_tgt_rsp_req ) 
+          else if ( r_xram_rsp_to_tgt_rsp_req )
           {
             r_tgt_rsp_fsm = TGT_RSP_XRAM;
@@ -5023,7 +5413,7 @@
         }
         //////////////////
-        case TGT_RSP_READ:		// send the response to a read 
-        {
-            if ( p_vci_tgt.rspack ) 
+        case TGT_RSP_READ:    // send the response to a read
+        {
+            if ( p_vci_tgt.rspack )
             {
 
@@ -5038,10 +5428,10 @@
 }
 #endif
-                if ( r_tgt_rsp_cpt.read() == (r_read_to_tgt_rsp_word.read()+r_read_to_tgt_rsp_length-1) ) 
+                if ( r_tgt_rsp_cpt.read() == (r_read_to_tgt_rsp_word.read()+r_read_to_tgt_rsp_length-1) )
                 {
                     r_tgt_rsp_fsm = TGT_RSP_READ_IDLE;
                     r_read_to_tgt_rsp_req = false;
-                } 
-                else 
+                }
+                else
                 {
                     r_tgt_rsp_cpt = r_tgt_rsp_cpt.read() + 1;
@@ -5051,7 +5441,7 @@
         }
         ///////////////////
-        case TGT_RSP_WRITE:		// send the write acknowledge
-        {
-            if ( p_vci_tgt.rspack ) 
+        case TGT_RSP_WRITE:   // send the write acknowledge
+        {
+            if ( p_vci_tgt.rspack )
             {
 
@@ -5070,7 +5460,7 @@
         }
         ///////////////////
-        case TGT_RSP_CLEANUP:		// pas clair pour moi (AG)   
-        {
-            if ( p_vci_tgt.rspack ) 
+        case TGT_RSP_CLEANUP:   // pas clair pour moi (AG)
+        {
+            if ( p_vci_tgt.rspack )
             {
 
@@ -5089,7 +5479,7 @@
         }
         //////////////////
-        case TGT_RSP_SC:		// send one atomic word response
-        {
-            if ( p_vci_tgt.rspack ) 
+        case TGT_RSP_SC:    // send one atomic word response
+        {
+            if ( p_vci_tgt.rspack )
             {
 
@@ -5109,7 +5499,7 @@
 
         ///////////////////////
-        case TGT_RSP_XRAM:		// send the response after XRAM access
-        {
-            if ( p_vci_tgt.rspack ) 
+        case TGT_RSP_XRAM:    // send the response after XRAM access
+        {
+            if ( p_vci_tgt.rspack )
             {
 
@@ -5124,12 +5514,12 @@
 }
 #endif
-                if ( (r_tgt_rsp_cpt.read() == 
+                if ( (r_tgt_rsp_cpt.read() ==
                      (r_xram_rsp_to_tgt_rsp_word.read()+r_xram_rsp_to_tgt_rsp_length.read()-1))
-                   || r_xram_rsp_to_tgt_rsp_rerror.read() ) 
+                   || r_xram_rsp_to_tgt_rsp_rerror.read() )
                 {
                     r_tgt_rsp_fsm = TGT_RSP_XRAM_IDLE;
                     r_xram_rsp_to_tgt_rsp_req = false;
-                } 
-                else 
+                }
+                else
                 {
                     r_tgt_rsp_cpt = r_tgt_rsp_cpt.read() + 1;
@@ -5139,7 +5529,7 @@
         }
         //////////////////
-        case TGT_RSP_INIT:		// send the write response after coherence transaction
-        {
-            if ( p_vci_tgt.rspack ) 
+        case TGT_RSP_INIT:    // send the write response after coherence transaction
+        {
+            if ( p_vci_tgt.rspack )
             {
 
@@ -5160,8 +5550,8 @@
 
     ////////////////////////////////////////////////////////////////////////////////////
-    //		ALLOC_UPT FSM
+    //    ALLOC_UPT FSM
     ////////////////////////////////////////////////////////////////////////////////////
     // The ALLOC_UPT FSM allocates the access to the Update/Inval Table (UPT).
-    // with a round robin priority between three FSMs : INIT_RSP > WRITE > XRAM_RSP > CLEANUP 
+    // with a round robin priority between three FSMs : INIT_RSP > WRITE > XRAM_RSP > CLEANUP
     // - The WRITE FSM initiates update transactions and sets  new entry in UPT.
     // - The XRAM_RSP FSM initiates inval transactions and sets  new entry in UPT.
@@ -5171,18 +5561,25 @@
     /////////////////////////////////////////////////////////////////////////////////////
 
-    switch ( r_alloc_upt_fsm.read() ) 
+    switch ( r_alloc_upt_fsm.read() )
     {
 
       ////////////////////////
       case ALLOC_UPT_INIT_RSP:
-        if ( (r_init_rsp_fsm.read() != INIT_RSP_UPT_LOCK) && 
-             (r_init_rsp_fsm.read() != INIT_RSP_UPT_CLEAR) ) 
-        {
-          if      ((r_write_fsm.read() == WRITE_UPT_LOCK) ||
-                   (r_write_fsm.read() == WRITE_BC_UPT_LOCK))        r_alloc_upt_fsm = ALLOC_UPT_WRITE;
-          else if (r_xram_rsp_fsm.read() == XRAM_RSP_INVAL_LOCK)    r_alloc_upt_fsm = ALLOC_UPT_XRAM_RSP;
-          else if (r_cleanup_fsm.read() == CLEANUP_UPT_LOCK)        r_alloc_upt_fsm = ALLOC_UPT_CLEANUP;
-          else if ((r_sc_fsm.read() == SC_UPT_LOCK) ||
-                   (r_sc_fsm.read() == SC_BC_UPT_LOCK))            r_alloc_upt_fsm = ALLOC_UPT_SC;
+        if (( r_init_rsp_fsm.read() != INIT_RSP_UPT_LOCK  ) &&
+            ( r_init_rsp_fsm.read() != INIT_RSP_UPT_CLEAR ))
+        {
+          if (( r_write_fsm.read() == WRITE_UPT_LOCK    ) ||
+              ( r_write_fsm.read() == WRITE_BC_UPT_LOCK ))
+            r_alloc_upt_fsm = ALLOC_UPT_WRITE;
+
+          else if ( r_xram_rsp_fsm.read() == XRAM_RSP_INVAL_LOCK )
+            r_alloc_upt_fsm = ALLOC_UPT_XRAM_RSP;
+
+          else if ( r_cleanup_fsm.read() == CLEANUP_UPT_LOCK )
+            r_alloc_upt_fsm = ALLOC_UPT_CLEANUP;
+
+          else if (( r_sc_fsm.read() == SC_UPT_LOCK    ) ||
+                   ( r_sc_fsm.read() == SC_BC_UPT_LOCK ))
+            r_alloc_upt_fsm = ALLOC_UPT_SC;
         }
         break;
@@ -5190,12 +5587,19 @@
         /////////////////////
       case ALLOC_UPT_WRITE:
-        if ( (r_write_fsm.read() != WRITE_UPT_LOCK) &&
-             (r_write_fsm.read() != WRITE_BC_UPT_LOCK)) 
-        {
-          if      (r_xram_rsp_fsm.read() == XRAM_RSP_INVAL_LOCK)    r_alloc_upt_fsm = ALLOC_UPT_XRAM_RSP;
-          else if (r_cleanup_fsm.read() == CLEANUP_UPT_LOCK)        r_alloc_upt_fsm = ALLOC_UPT_CLEANUP;
-          else if ((r_sc_fsm.read() == SC_UPT_LOCK) ||
-                   (r_sc_fsm.read() == SC_BC_UPT_LOCK))            r_alloc_upt_fsm = ALLOC_UPT_SC;
-          else if (r_init_rsp_fsm.read() == INIT_RSP_UPT_LOCK)      r_alloc_upt_fsm = ALLOC_UPT_INIT_RSP;
+        if (( r_write_fsm.read() != WRITE_UPT_LOCK    ) &&
+            ( r_write_fsm.read() != WRITE_BC_UPT_LOCK ))
+        {
+          if ( r_xram_rsp_fsm.read() == XRAM_RSP_INVAL_LOCK )
+            r_alloc_upt_fsm = ALLOC_UPT_XRAM_RSP;
+
+          else if ( r_cleanup_fsm.read() == CLEANUP_UPT_LOCK )
+            r_alloc_upt_fsm = ALLOC_UPT_CLEANUP;
+
+          else if (( r_sc_fsm.read() == SC_UPT_LOCK    ) ||
+                   ( r_sc_fsm.read() == SC_BC_UPT_LOCK ))
+            r_alloc_upt_fsm = ALLOC_UPT_SC;
+
+          else if ( r_init_rsp_fsm.read() == INIT_RSP_UPT_LOCK )
+            r_alloc_upt_fsm = ALLOC_UPT_INIT_RSP;
         }
         break;
@@ -5203,12 +5607,19 @@
         ////////////////////////
       case ALLOC_UPT_XRAM_RSP:
-        if (r_xram_rsp_fsm.read() != XRAM_RSP_INVAL_LOCK) 
-        { 
-          if       (r_cleanup_fsm.read() == CLEANUP_UPT_LOCK)       r_alloc_upt_fsm = ALLOC_UPT_CLEANUP;
-          else if ((r_sc_fsm.read() == SC_UPT_LOCK) ||
-                   (r_sc_fsm.read() == SC_BC_UPT_LOCK))            r_alloc_upt_fsm = ALLOC_UPT_SC;
-          else if  (r_init_rsp_fsm.read() == INIT_RSP_UPT_LOCK)     r_alloc_upt_fsm = ALLOC_UPT_INIT_RSP;
-          else if ((r_write_fsm.read() == WRITE_UPT_LOCK)   ||
-                   (r_write_fsm.read() == WRITE_BC_UPT_LOCK))        r_alloc_upt_fsm = ALLOC_UPT_WRITE;
+        if (r_xram_rsp_fsm.read() != XRAM_RSP_INVAL_LOCK)
+        {
+          if ( r_cleanup_fsm.read() == CLEANUP_UPT_LOCK )
+            r_alloc_upt_fsm = ALLOC_UPT_CLEANUP;
+
+          else if (( r_sc_fsm.read() == SC_UPT_LOCK    ) ||
+                   ( r_sc_fsm.read() == SC_BC_UPT_LOCK ))
+            r_alloc_upt_fsm = ALLOC_UPT_SC;
+
+          else if ( r_init_rsp_fsm.read() == INIT_RSP_UPT_LOCK )
+            r_alloc_upt_fsm = ALLOC_UPT_INIT_RSP;
+
+          else if (( r_write_fsm.read() == WRITE_UPT_LOCK    )   ||
+                   ( r_write_fsm.read() == WRITE_BC_UPT_LOCK ))
+            r_alloc_upt_fsm = ALLOC_UPT_WRITE;
         }
         break;
@@ -5218,23 +5629,37 @@
         if(r_cleanup_fsm.read() != CLEANUP_UPT_LOCK )
         {
-          if      ((r_sc_fsm.read() == SC_UPT_LOCK) ||
-                   (r_sc_fsm.read() == SC_BC_UPT_LOCK))            r_alloc_upt_fsm = ALLOC_UPT_SC;
-          else if  (r_init_rsp_fsm.read() == INIT_RSP_UPT_LOCK)     r_alloc_upt_fsm = ALLOC_UPT_INIT_RSP;
-          else if ((r_write_fsm.read() == WRITE_UPT_LOCK) ||
-                   (r_write_fsm.read() == WRITE_BC_UPT_LOCK))        r_alloc_upt_fsm = ALLOC_UPT_WRITE;
-          else if (r_xram_rsp_fsm.read() == XRAM_RSP_INVAL_LOCK)    r_alloc_upt_fsm = ALLOC_UPT_XRAM_RSP;
+          if (( r_sc_fsm.read() == SC_UPT_LOCK    ) ||
+              ( r_sc_fsm.read() == SC_BC_UPT_LOCK ))
+            r_alloc_upt_fsm = ALLOC_UPT_SC;
+
+          else if ( r_init_rsp_fsm.read() == INIT_RSP_UPT_LOCK )
+            r_alloc_upt_fsm = ALLOC_UPT_INIT_RSP;
+
+          else if (( r_write_fsm.read() == WRITE_UPT_LOCK    ) ||
+                   ( r_write_fsm.read() == WRITE_BC_UPT_LOCK ))
+            r_alloc_upt_fsm = ALLOC_UPT_WRITE;
+
+          else if ( r_xram_rsp_fsm.read() == XRAM_RSP_INVAL_LOCK )
+            r_alloc_upt_fsm = ALLOC_UPT_XRAM_RSP;
         }
         break;
-        
+
         //////////////////////////
       case ALLOC_UPT_SC:
-        if( (r_sc_fsm.read() != SC_UPT_LOCK) && 
-            (r_sc_fsm.read() != SC_BC_UPT_LOCK))
-        {
-          if      (r_init_rsp_fsm.read() == INIT_RSP_UPT_LOCK)      r_alloc_upt_fsm = ALLOC_UPT_INIT_RSP;
-          else if ((r_write_fsm.read() == WRITE_UPT_LOCK) ||
-                   (r_write_fsm.read() == WRITE_BC_UPT_LOCK))        r_alloc_upt_fsm = ALLOC_UPT_WRITE;
-          else if (r_xram_rsp_fsm.read() == XRAM_RSP_INVAL_LOCK)    r_alloc_upt_fsm = ALLOC_UPT_XRAM_RSP;
-          else if (r_cleanup_fsm.read() == CLEANUP_UPT_LOCK)        r_alloc_upt_fsm = ALLOC_UPT_CLEANUP;
+        if (( r_sc_fsm.read() != SC_UPT_LOCK    ) &&
+            ( r_sc_fsm.read() != SC_BC_UPT_LOCK ))
+        {
+          if ( r_init_rsp_fsm.read() == INIT_RSP_UPT_LOCK )
+            r_alloc_upt_fsm = ALLOC_UPT_INIT_RSP;
+
+          else if (( r_write_fsm.read() == WRITE_UPT_LOCK    ) ||
+                   ( r_write_fsm.read() == WRITE_BC_UPT_LOCK ))
+            r_alloc_upt_fsm = ALLOC_UPT_WRITE;
+
+          else if ( r_xram_rsp_fsm.read() == XRAM_RSP_INVAL_LOCK )
+            r_alloc_upt_fsm = ALLOC_UPT_XRAM_RSP;
+
+          else if ( r_cleanup_fsm.read() == CLEANUP_UPT_LOCK )
+            r_alloc_upt_fsm = ALLOC_UPT_CLEANUP;
         }
         break;
@@ -5243,5 +5668,5 @@
 
     ////////////////////////////////////////////////////////////////////////////////////
-    //		ALLOC_DIR FSM
+    //    ALLOC_DIR FSM
     ////////////////////////////////////////////////////////////////////////////////////
     // The ALLOC_DIR FSM allocates the access to the directory and
@@ -5251,22 +5676,43 @@
     /////////////////////////////////////////////////////////////////////////////////////
 
-    switch ( r_alloc_dir_fsm.read() ) 
+    switch ( r_alloc_dir_fsm.read() )
     {
+      case ALLOC_DIR_RESET:
+        // Initializes the directory one SET each cycle. All the WAYS of a SET are
+        // initialize in parallel
+
+        r_alloc_dir_reset_cpt.write(r_alloc_dir_reset_cpt.read() + 1);
+
+        if (r_alloc_dir_reset_cpt.read() == (m_sets - 1)) {
+          m_cache_directory.init();
+
+          r_alloc_dir_fsm = ALLOC_DIR_READ;
+        }
+        break;
+
       ////////////////////
       case ALLOC_DIR_READ:
-        if ( ( (r_read_fsm.read() != READ_DIR_LOCK) &&
-              (r_read_fsm.read() != READ_TRT_LOCK)  &&
-              (r_read_fsm.read() != READ_HEAP_LOCK))
+        if ((( r_read_fsm.read()       != READ_DIR_REQ    )   &&
+             ( r_read_fsm.read()       != READ_DIR_LOCK   )   &&
+             ( r_read_fsm.read()       != READ_TRT_LOCK   )   &&
+             ( r_read_fsm.read()       != READ_HEAP_REQ   ))
             ||
-            ( (r_read_fsm.read()        == READ_HEAP_LOCK) &&
-              (r_alloc_heap_fsm.read()  == ALLOC_HEAP_READ) )
+            (( r_read_fsm.read()       == READ_HEAP_REQ   )   &&
+             ( r_alloc_heap_fsm.read() == ALLOC_HEAP_READ ))
             ||
-            ( (r_read_fsm.read()      == READ_TRT_LOCK)  &&
-              (r_alloc_trt_fsm.read() == ALLOC_TRT_READ)    )  ) 
-        {
-          if        (r_write_fsm.read() == WRITE_DIR_LOCK)          r_alloc_dir_fsm = ALLOC_DIR_WRITE;
-          else if   (r_sc_fsm.read() == SC_DIR_LOCK)              r_alloc_dir_fsm = ALLOC_DIR_SC;
-          else if   (r_cleanup_fsm.read() == CLEANUP_DIR_LOCK)      r_alloc_dir_fsm = ALLOC_DIR_CLEANUP;
-          else if   (r_xram_rsp_fsm.read() == XRAM_RSP_DIR_LOCK)    r_alloc_dir_fsm = ALLOC_DIR_XRAM_RSP;
+            (( r_read_fsm.read()       == READ_TRT_LOCK   )   &&
+             ( r_alloc_trt_fsm.read()  == ALLOC_TRT_READ  )))
+        {
+          if (r_write_fsm.read() == WRITE_DIR_REQ)
+            r_alloc_dir_fsm = ALLOC_DIR_WRITE;
+
+          else if (r_sc_fsm.read() == SC_DIR_REQ)
+            r_alloc_dir_fsm = ALLOC_DIR_SC;
+
+          else if (r_cleanup_fsm.read() == CLEANUP_DIR_REQ )
+            r_alloc_dir_fsm = ALLOC_DIR_CLEANUP;
+
+          else if (r_xram_rsp_fsm.read() == XRAM_RSP_DIR_LOCK)
+            r_alloc_dir_fsm = ALLOC_DIR_XRAM_RSP;
         }
         break;
@@ -5274,23 +5720,31 @@
         /////////////////////
       case ALLOC_DIR_WRITE:
-        if ( ((r_write_fsm.read() != WRITE_DIR_LOCK) &&
-              (r_write_fsm.read() != WRITE_MISS_TRT_LOCK) &&
-              (r_write_fsm.read() != WRITE_DIR_READ) &&
-              (r_write_fsm.read() != WRITE_DIR_HIT) &&
-              (r_write_fsm.read() != WRITE_BC_TRT_LOCK) &&
-              (r_write_fsm.read() != WRITE_BC_UPT_LOCK) &&
-              (r_write_fsm.read() != WRITE_UPT_LOCK) &&
-              (r_write_fsm.read() != WRITE_UPT_HEAP_LOCK))
+        if ((( r_write_fsm.read()      != WRITE_DIR_REQ       )  &&
+             ( r_write_fsm.read()      != WRITE_DIR_LOCK      )  &&
+             ( r_write_fsm.read()      != WRITE_DIR_READ      )  &&
+             ( r_write_fsm.read()      != WRITE_DIR_HIT       )  &&
+             ( r_write_fsm.read()      != WRITE_BC_TRT_LOCK   )  &&
+             ( r_write_fsm.read()      != WRITE_BC_UPT_LOCK   )  &&
+             ( r_write_fsm.read()      != WRITE_MISS_TRT_LOCK )  &&
+             ( r_write_fsm.read()      != WRITE_UPT_LOCK      )  &&
+             ( r_write_fsm.read()      != WRITE_UPT_HEAP_LOCK ))
             ||
-            ( (r_write_fsm.read()       == WRITE_UPT_HEAP_LOCK) &&
-              (r_alloc_heap_fsm.read()  == ALLOC_HEAP_WRITE) )
+            (( r_write_fsm.read()      == WRITE_UPT_HEAP_LOCK )  &&
+             ( r_alloc_heap_fsm.read() == ALLOC_HEAP_WRITE    ))
             ||
-            ( (r_write_fsm.read()     == WRITE_MISS_TRT_LOCK) &&
-              (r_alloc_trt_fsm.read() == ALLOC_TRT_WRITE)   )   )
-        {
-          if        (r_sc_fsm.read() == SC_DIR_LOCK)              r_alloc_dir_fsm = ALLOC_DIR_SC;
-          else if   (r_cleanup_fsm.read() == CLEANUP_DIR_LOCK)      r_alloc_dir_fsm = ALLOC_DIR_CLEANUP;
-          else if   (r_xram_rsp_fsm.read() == XRAM_RSP_DIR_LOCK)    r_alloc_dir_fsm = ALLOC_DIR_XRAM_RSP;
-          else if   (r_read_fsm.read() == READ_DIR_LOCK) 	        r_alloc_dir_fsm = ALLOC_DIR_READ;
+            (( r_write_fsm.read()      == WRITE_MISS_TRT_LOCK )  &&
+             ( r_alloc_trt_fsm.read()  == ALLOC_TRT_WRITE     )))
+        {
+          if ( r_sc_fsm.read() == SC_DIR_REQ )
+            r_alloc_dir_fsm = ALLOC_DIR_SC;
+
+          else if ( r_cleanup_fsm.read() == CLEANUP_DIR_REQ )
+            r_alloc_dir_fsm = ALLOC_DIR_CLEANUP;
+
+          else if ( r_xram_rsp_fsm.read() == XRAM_RSP_DIR_LOCK )
+            r_alloc_dir_fsm = ALLOC_DIR_XRAM_RSP;
+
+          else if ( r_read_fsm.read() == READ_DIR_REQ )
+            r_alloc_dir_fsm = ALLOC_DIR_READ;
         }
         break;
